package com.ruoyi.service.impl;

import com.ruoyi.domain.ReviewScene;
import com.ruoyi.domain.ReviewSceneChangeTask;
import com.ruoyi.mapper.ReviewSceneMapper;
import com.ruoyi.service.StrategyReviewSceneChange;
import com.ruoyi.service.ReviewSceneChangeTaskService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Transactional
@Service(ReviewSceneChangeTask.OPERATION_ADD)
public class StrategyReviewSceneChangeAdd implements StrategyReviewSceneChange {

    @Autowired
    private ReviewSceneMapper reviewSceneMapper;

    @Autowired
    private ReviewSceneChangeTaskService reviewSceneChangeTaskService;

    /**
     * 新增审查场景
     * @param reviewSceneChangeTask
     */
    @Override
    public void doChange(ReviewSceneChangeTask reviewSceneChangeTask) {

        // 保存新增的场景
        ReviewScene reviewScene = new ReviewScene()
                .setText(reviewSceneChangeTask.getNewText())
                .setReviewDetailsId(reviewSceneChangeTask.getDetailsId());
        reviewSceneMapper.insert(reviewScene);

        // 为场景变更任务的 场景关联id字段赋值
        reviewSceneChangeTask.setReviewSceneId(reviewScene.getId());
        reviewSceneChangeTaskService.updateById(reviewSceneChangeTask);

    }

}
