package com.ruoyi.web;

import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.domain.Book;
import com.ruoyi.service.BookService;
import org.apache.skywalking.apm.toolkit.trace.Tag;
import org.apache.skywalking.apm.toolkit.trace.Tags;
import org.apache.skywalking.apm.toolkit.trace.Trace;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.List;


@RestController
@RequestMapping("/book")
public class BookController extends BaseController {

    @Autowired
    private BookService bookService;
    @Trace
    @Tags({@Tag(key = "param", value = "arg[0]"), @Tag(key = "result", value = "returnedObj")})
    @RequestMapping(method = RequestMethod.POST, value = "/add")
    public AjaxResult add(@Validated @RequestBody Book book) {
        return toAjax(bookService.save(book));
    }
    @Trace
    @Tags({@Tag(key = "param", value = "arg[0]"), @Tag(key = "result", value = "returnedObj")})
    @RequestMapping(method = RequestMethod.POST, value = "/edit")
    public AjaxResult edit(@Validated @RequestBody Book book) {
        return toAjax(bookService.updateById(book));
    }
    @Trace
    @Tags({@Tag(key = "param", value = "arg[0]"), @Tag(key = "result", value = "returnedObj")})
    @RequestMapping(method = RequestMethod.POST, value = "/list")
    public TableDataInfo list(@Validated @RequestBody Book book) {
        startPage();
        List<Book> books = bookService.selectBookList(book);
        return getDataTable(books);
    }
    @Trace
    @Tags({@Tag(key = "param", value = "arg[0]"), @Tag(key = "result", value = "returnedObj")})
    @RequestMapping(method = RequestMethod.POST, value = "/remove")
    public AjaxResult remove(@Validated @RequestBody Long[] userIds) {
        return toAjax(bookService.removeBatchByIds(Arrays.asList(userIds)));
    }

    @Trace
    @Tags({@Tag(key = "param", value = "arg[0]"), @Tag(key = "result", value = "returnedObj")})
    @RequestMapping(method = RequestMethod.POST, value = "/listException")
    public TableDataInfo listException(@Validated @RequestBody Book book) {
        startPage();
        List<Book> books = bookService.selectBookListException(book);
        return getDataTable(books);
    }

}
